<script lang="ts">
import { computed, provide, ref, shallowRef, watch } from 'vue';

export default {
  name: 'JDynamicVirtualScroll',
  props: {
    items: {
      type: Array,
      default: () => [],
    },
    partialStep: {
      type: Number,
      default: 30,
    },
  },
  setup(props) {
    const viewportRef = ref<HTMLElement | null>(null);

    const itemsHeight = ref<number[]>([]);

    const currentScrollHeight = ref(0);
    const currentStep = ref(props.partialStep);

    const partialItems = shallowRef(props.items.slice(0, currentStep.value));

    const addToCurrentHeight = (height: number) => {
      itemsHeight.value.push(height);
      currentScrollHeight.value += height;
    };

    provide('virtualScrollHeight', currentScrollHeight);
    provide('addToCurrentHeight', addToCurrentHeight);

    let currentItemsHeight = 0;
    let currentVisibleNodes = 0;
    let isEndParticalRender = ref(false);

    const partialItemsRender = () => {
      if (viewportRef.value === null) return;
      if (currentStep.value >= props.items.length - 1) {
        if (isEndParticalRender.value) return;

        isEndParticalRender.value = true;
      }

      for (let index = currentStep.value - props.partialStep; index < currentStep.value; index++) {
        if (
          currentItemsHeight + itemsHeight.value[index] > viewportRef.value.offsetHeight &&
          currentItemsHeight > viewportRef.value.offsetHeight
        ) {
          break;
        } else {
          currentVisibleNodes = index;
          currentItemsHeight += itemsHeight.value[index];
        }
      }

      const prevStep = currentStep.value;
      currentStep.value += props.partialStep;

      const newItems = props.items.slice(prevStep, currentStep.value + 1);
      const currentItems = partialItems.value.slice(0, currentVisibleNodes + 1);

      partialItems.value = currentItems.concat(newItems);

      requestAnimationFrame(() => {
        partialItemsRender();
      });
    };

    requestAnimationFrame(partialItemsRender);

    let currentStartNode = 0;

    const handleScroll = (event: WheelEvent) => {
      const target = event.target as HTMLElement;
      
      if (viewportRef.value === null) return;

      if (currentItemsHeight - (target.scrollTop + 150) >= viewportRef.value.offsetHeight) {
        return;
      }
    };

    return {
      isEndParticalRender,
      viewportRef,
      partialItems,
      currentScrollHeight,
      handleScroll,
    };
  },
};
</script>

<template>
  <slot
    :set-ref="(el) => (viewportRef = el)"
    :new-items="partialItems"
    :total-height="currentScrollHeight"
    :is-end-render="isEndParticalRender"
    :on-scroll="handleScroll"
  />
</template>

<style scoped></style>
